program owscale

use sep
implicit none
logical                             :: rms
real,allocatable                    :: data(:,:,:,:,:), a(:,:),temp(:,:)
integer                             :: i1,i2,i3,i4,i5,n1,n2,n3,n4,n5,wx,wy
real                                :: d1,d2,d3,d4,d5,o1,o2,o3,o4,o5

call sep_init()
call sep_begin_prog()
call from_param("rms",rms,.true.)
call from_param("wy",wy,10)
call from_param("wx",wx,10)
call from_history("n1",n1); call from_history("d1",d1); call from_history("o1",o1)
call from_history("n2",n2); call from_history("d2",d2); call from_history("o2",o2)
call from_history("n3",n3); call from_history("d3",d3); call from_history("o3",o3)
call from_history("n4",n4); call from_history("d4",d4); call from_history("o4",o4)
call from_history("n5",n5); call from_history("d5",d5); call from_history("o5",o5)

call to_history("n1",n1); call to_history("d1",d1); call to_history("o1",o1)
call to_history("n2",n2); call to_history("d2",d2); call to_history("o2",o2)
call to_history("n3",n3); call to_history("d3",d3); call to_history("o3",o3)
call to_history("n4",n4); call to_history("d4",d4); call to_history("o4",o4)
call to_history("n5",n5); call to_history("d5",d5); call to_history("o5",o5)
call to_history("eout",4);call to_history("label3","")
allocate(data(n1,n2,n3,n4,n5),a(n1,n3),temp(n1,n3))
call sreed("in", data, 4*n1*n2*n3*n4*n5)
if (rms) then
  a=0
  do i4=1,n4;do i3=1,n3;do i2=1,n2;do i1=1,n1
     a(i1,i3) = a(i1,i3) + sum(data(i1,i2,i3,i4,:)**2)
  end do;end do;end do;end do
  a = sqrt(a/n1/n2/n3/n4/n5)
  temp=0;
  do i3=1,n3;do i1=1,n1
     temp(i1,i3)=sum(a(max(1,i1-wx):min(n1,i1+wx),i3))/(min(n1,i1+wx)-max(1,i1-wx)+1)
  end do;end do
  do i3=1,n3;do i1=1,n1
     a(i1,i3)=sum(temp(i1,max(1,i3-wy):min(n3,i3+wy)))/(min(n3,i3+wy)-max(1,i3-wy)+1)
  end do;end do
  do i3=1,n3;do i1=1,n1
     if(a(i1,i3).ne.0)  data(i1,:,i3,:,:)=data(i1,:,i3,:,:)/a(i1,i3)
  end do;end do
else
  a=tiny(1.)
  do i4=1,n4;do i3=1,n3;do i2=1,n2;do i1=1,n1
     if (maxval(abs(data(i1,i2,i3,i4,:))) > a(i1,i3)) a(i1,i3)=maxval(abs(data(i1,i2,i3,i4,:)))
  end do;end do;end do;end do
  temp=0;
  do i3=1,n3;do i1=1,n1
     temp(i1,i3)=sum(a(max(1,i1-wx):min(n1,i1+wx),i3))/(min(n1,i1+wx)-max(1,i1-wx)+1)
  end do;end do
  do i3=1,n3;do i1=1,n1
     a(i1,i3)=sum(temp(i1,max(1,i3-wy):min(n3,i3+wy)))/(min(n3,i3+wy)-max(1,i3-wy)+1)
  end do;end do
  do i3=1,n3;do i1=1,n1
     if(a(i1,i3).ne.0)  data(i1,:,i3,:,:)=data(i1,:,i3,:,:)/a(i1,i3)
  end do;end do
end if
call to_history("n1",n1,"scale"); call to_history("d1",d1,"scale"); call to_history("o1",o1,"scale")  
call to_history("n2",n3,"scale"); call to_history("d2",d3,"scale"); call to_history("o2",o3,"scale")  
call to_history("n3",1,"scale") ; call to_history("d3",1.,"scale") ; call to_history("o3",1.,"scale")
call to_history("esize",4,"scale")
call srite("scale",a,4*n1*n3)

call srite("out", data, 4*n1*n2*n3*n4*n5)
deallocate(data,a,temp)
call sep_end_prog()
end program
