module OW_type

public 						:: axis, dat_grid, mod_grid, velo,block
!--------------------------------------------------
  !!.. define type for axes
  type axis 
    integer 					:: n		! total number
    real    					:: d		! spacing
    real    					:: o		! origin
    real, allocatable				:: all(:)	! values
  end type

!---------------------------------------------------
  !!.. define data grid
  type dat_grid
    type(axis) :: w, x, y
  end type
!---------------------------------------------------
  !!.. define model grid
  type mod_grid
    type(axis) :: z, shx, xm, shy, ym
  end type
!---------------------------------------------------
  !!.. define vel
  type velo
    type(axis) :: z, xm, ym
  end type
!----------------------------------------------------
  type block
    integer                            :: ns
    integer                            :: nb
    integer                            :: nb_res
    real                               :: ds
    real   , allocatable, dimension(:) :: os
    integer, allocatable, dimension(:) :: blen
    integer, allocatable, dimension(:) :: indx
    logical                            :: bres
  end type

end module
