program OWtim2off

use sep 
use OW_type
use OW_exec_time
use OW_parms_slt
use OW_slant1
!use OW_dotst

implicit none

real                                          :: start, finish, start1, finish1, start2, finish2
real                                          :: stat
real, allocatable                             :: velint(:),vel(:)
real, allocatable                             :: R_image(:,:,:),B_image(:,:,:)
integer				      :: nv,j,k

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 call sep_init()
 call sep_begin_prog()
 start=0.;finish=0.
 call owexec_time(start)
 call owparam()
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Set up the taper
! call owtaper(tapertr,taper)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Read velocities
 allocate(velint(v%xm%n*v%z%n),vel(img%xm%n*img%z%n))
 call sreed("vel",velint,v%z%n*v%xm%n*4)
 nv = floor((img%xm%o-v%xm%o)/v%xm%d)+1
 vel=0
 do k=1,img%z%n
 do j=nv,nv+img%xm%n-1
    if (velint((k-1)*v%xm%n+j) == 0) then
       vel((k-1)*img%xm%n+j-nv+1)=0
    else
       vel((k-1)*img%xm%n+j-nv+1)=velint((k-1)*v%xm%n+j)
    end if
 end do
 end do
 deallocate(velint)
 if (adj) then 
    allocate(R_image(img%xm%n,img%th%n,img%z%n));R_image=0.
    allocate(B_image(img%xm%n,nah,img%z%n));B_image=0.
 else
    allocate(R_image(img%xm%n,nah,img%z%n));R_image=0.
    allocate(B_image(img%xm%n,img%th%n,img%z%n));B_image=0.
 end if
 if (adj) then 
    call sreed("R_image",R_image,4*img%z%n*img%th%n*img%xm%n)
 else
    call sreed("R_image",R_image,4*img%z%n*nah*img%xm%n)
 end if
 stat = owslant_init(v_in=vel)
 call owslant_exe(adj,.false.,B_image,R_image)
 if (adj) then 
    call srite("B_image",B_image,4*img%z%n*nah*img%xm%n)
 else
    call srite("B_image",B_image,4*img%z%n*img%th%n*img%xm%n)
 end if
 stat = owslant_close()
 deallocate(R_image,B_image)
 deallocate(vel)
 call sep_end_prog()
end program
