#!/bin/tcsh 
#
#
# (c) 2004 Sun Microsystems, Inc. Use is subject to license terms.
#
#$-cwd
# ---------------------------
# our name
#
# pe request
#$ -pe mpich 128-128 
#

# Get master node name
set a=`hostname`
echo "MASTER NODE $a "

# Get machine names
cat $TMPDIR/machines| sed "/$a/d">mfile1

# Select non repeated names
ceesnode

# Get number of nodes
@ n1= `wc -l mfile | awk '{print $1}'` 
echo $n1
@ NSLOTS=$n1 + 1
echo $NSLOTS
echo "Got $NSLOTS slots."

# Set datapaths to be used
echo "datapath=/tmp/" > .datapath
echo "$a datapath=/data/temp1/guerrac/" >> .datapath
mpirun -np $NSLOTS -machinefile mfile /data/temp1/guerrac/Bin/nlin_dir.x sou=sgx45gy1.H rec=rgx45gy1.H vel=elf.L7f.vinit.rmo2.grid30.dz15.H grad=elf.grad2nl.gx45scchsmo.H Dimage=elf.dimg2nl.gx45scchsmo.H bkgimg=elf.bimg2nl.gx45scchsmo.H Velout=elf.vout2nl.gx45scchsmo.H grad_=elf.grad_2nl.gx45scchsmo.H vtemp=elf.vtemp2nl.gx45scchsmo.H scale=elf.scale2nl.gx45scchsmo.H par=chalk2.P
